// C Source File
// Created 2001-08-21; 09:29:45
/*
================================
Jes Bean : A brain busting
game for 1 or 2 persons from
JEsystems: 
http://jesystems.cjb.net
================================
*/
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#define ME	1
#define AI	2

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"

short _ti92plus;              // Produce .9XZ File
short _ti89;

short HW2=0;

void beep(short freq, long duree,int sound)
{

	long int loop, maxloop = freq*duree/50 ;
	short int i, j;
	if (!(sound)) return;
	j = peekIO(0x60000E);	
	freq = (HW2 ? 364000 : 278000)/freq ;
	pokeIO(0x60000C, 6) ;
	for (loop = 0 ; loop < maxloop ; loop++)
	{
		pokeIO(0x60000E, j ^= 0x03) ;
		for (i = 0 ; i <= freq ; i--) i += 2 ;
	}
	pokeIO(0x60000E, 0);
//	pokeIO(0x60000E, 1);
	pokeIO(0x60000C, 0x8D) ;
}

void Draw_Board(int board[3][6])
{
	static unsigned short house[] = {0x0180,0x03DC,0x0674,0x0C34,0x1814,0x3184,0x6246,0xC3C7,0xC003,0x4002,0x4002,0x4002,0x4002,0x4002,0x4002,0x7FFE};
	int temp=0;
	FontSetSys (F_4x6);
	// Horizontal
	FastDrawLine(GetPlane(DARK_PLANE),10,18,130,18,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),10,26,130,26,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),10,58,130,58,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),10,66,130,66,A_NORMAL);
	// Vertical
	FastDrawLine(GetPlane(DARK_PLANE),10,58,10,66,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),130,58,130,66,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),10,18,10,26,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),130,18,130,26,A_NORMAL);

	FastDrawLine(GetPlane(DARK_PLANE),30,18,30,26,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),50,18,50,26,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),70,18,70,26,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),90,18,90,26,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),110,18,110,26,A_NORMAL);
	
	FastDrawLine(GetPlane(DARK_PLANE),30,58,30,66,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),50,58,50,66,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),70,58,70,66,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),90,58,90,66,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),110,58,110,66,A_NORMAL);
	
	// Arrows
	FastDrawLine(GetPlane(DARK_PLANE),130,58,138,62,A_NORMAL);	
	FastDrawLine(GetPlane(DARK_PLANE),130,66,138,62,A_NORMAL);	
	FastDrawLine(GetPlane(DARK_PLANE),10,18,2,22,A_NORMAL);
	FastDrawLine(GetPlane(DARK_PLANE),10,26,2,22,A_NORMAL);
	
	while(temp<6)
	{
		SetPlane(LIGHT_PLANE);
//		printf_xy(20+(20*temp),20,"%d",board[0][temp]);
		printf_xy(20+(20*temp),60,"%d  ",board[2][temp]);
		SetPlane(DARK_PLANE);
		printf_xy(20+(20*temp),20,"%d  ",board[0][temp]);
		printf_xy(20+(20*temp),60,"%d  ",board[2][temp]);
		temp++;
	}
	SetPlane(LIGHT_PLANE);
	printf_xy(136,42,"%d",board[1][5]);
	SetPlane(DARK_PLANE);
	printf_xy(4,42,"%d",board[1][0]);
	printf_xy(136,42,"%d",board[1][5]);
	Sprite16_OR(1,33,16,house,GetPlane(LIGHT_PLANE));
	Sprite16_OR(1,33,16,house,GetPlane(DARK_PLANE));
	Sprite16_OR(133,33,16,house,GetPlane(LIGHT_PLANE));
	Sprite16_OR(133,33,16,house,GetPlane(DARK_PLANE));
}

int RunAI(int board[3][6])
{
	int temp=0;
	if (board[0][0]==1) return 0;
	if (board[0][1]==2) return 1;
	if (board[0][2]==3) return 2;
	if (board[0][3]==4) return 3;
	if (board[0][4]==5) return 4;
	if (board[0][5]==6) return 5;
	
	temp = random(6);
	while (board[0][temp]==0)
	{
		temp = random(6);
	}
	return temp;
}

int Check_AI_empty(int board[3][6])
{
	if (board[0][0]>0) return 0;
	if (board[0][1]>0) return 0;
	if (board[0][2]>0) return 0;
	if (board[0][3]>0) return 0;
	if (board[0][4]>0) return 0;
	if (board[0][5]>0) return 0;
	return 1;
}

int Check_ME_empty(int board[3][6])
{
	if (board[2][0]>0) return 0;
	if (board[2][1]>0) return 0;
	if (board[2][2]>0) return 0;
	if (board[2][3]>0) return 0;
	if (board[2][4]>0) return 0;
	if (board[2][5]>0) return 0;
	return 1;
}

void Xor_hand(int x,int y)
{
	static unsigned short hand[][16] = {{0x0C00,0x1E00,0x1E00,0x1F80,0x1FC0,0x1FF0,0x7FF8,0xFFFE,0xFFFF,0xFFFF,0xFFFF,0x7FFF,0x7FFF,0x3FFE,0x3FFE,0x1FFC},{0x0C00,0x1200,0x1200,0x1380,0x1240,0x1270,0x7248,0x900E,0x8009,0x8001,0x8001,0x4001,0x4001,0x2002,0x2002,0x1FFC}};
	Sprite16_XOR(x,y,16,hand[0],GetPlane(LIGHT_PLANE));
	Sprite16_XOR(x,y,16,hand[1],GetPlane(DARK_PLANE));
}

// The game
void Run_Game(int sound)
{
	int board[3][6] = {{4,4,4,4,4,4},{0,0,0,0,0,0},{4,4,4,4,4,4}};
	int key=0;
	int my_x=0;
	int holder=0;
	int tempx=0;
	int tempy=0;
	int turn=ME;
	int exit=0;
	randomize();
	
	sound--; // gives 0 if dissabled, 1 if enabled
	
	ClearGrayScreen2B(GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
	
	Draw_Board(board);
	Xor_hand(15+(my_x*20),75);
//	printf_xy(20+(my_x*20),75,"^");
	
	while (key != KEY_ESC) { // while we don't push ESC..
		while (turn==AI) {
			exit=Check_AI_empty(board);
			if (exit) goto end;
			tempx=RunAI(board);
			printf_xy(1,1,"AI makes turn: %d",tempx);
			holder=board[0][tempx];
			board[0][tempx]=0;
			tempx--;
			tempy=0;
			while(holder>0)
			{
				if ((tempx<0) && (tempy==0))
				{
					tempy++;
					tempx=0;
				} else if (tempy==1) {
					tempx=0;
					tempy++;
				} else if ((tempy==2) && (tempx>5))
				{
					tempx=5;
				}
				board[tempy][tempx]++;
				holder--;
				if (tempy==2) tempx++;
				if (tempy==0) tempx--;
			}
			Draw_Board(board);
			if (tempy!=1) turn=ME;
		}
		exit=Check_ME_empty(board);
		if (exit) goto end;
		key = ngetchx();
		if ((key==KEY_RIGHT) && (my_x<5))
		{
			Xor_hand(15+(my_x*20),75);
			my_x++;
			Xor_hand(15+(my_x*20),75);
		}
		if ((key==KEY_LEFT) && (my_x>0))
		{
			Xor_hand(15+(my_x*20),75);
			my_x--;
			Xor_hand(15+(my_x*20),75);
		}
		if ((key==KEY_ENTER) && (board[2][my_x]>0))
		{
			holder=board[2][my_x];
			tempx=my_x+1;
			tempy=2;
			board[2][my_x]=0;
			while(holder>0)
			{
				if ((tempx>5) && (tempy==2))
				{
					tempy--;
					tempx=5;
				} else if ((tempy==1) && (tempx>=5)) {
					tempx=5;
					tempy--;
				} else if ((tempy==1) && (tempx<=0)) {
					tempx=0;
					tempy++;
				} else if ((tempy==0) && (tempx<=0)) {
					tempx=0;
					tempy++;
				}
				board[tempy][tempx]++;
				holder--;
				if (tempy==2) tempx++;
				if (tempy==0) tempx--;
			}
			Draw_Board(board);
			if (tempy!=1)	{
				turn = AI;
				beep(294,1,sound); //Picking up a block
				beep(349,2,sound);
			} else {
				beep(392,1,sound); //Jumping
				beep(587,2,sound);
			}
		}
	}
	return;
	end:
	printf_xy(1,1,"---[ END OF GAME : PRESS ENTER ]---");
	ngetchx();
	
}


int Menu(void)
{
	static unsigned short logo[][100] = {{0xFFFD,0xFF9D,0xFF1D,0xFF9D,0xF9FD,0xFFBD,0xFF3D,0xFFFD,0xFF3D,0xFE7D,0xFF7D,0xFE7D,0xFEFD,0xE1FD,0xF3FD,0xFFFD,0xFFFD,0xFC05,0xFC85,0xFEFD,0xFCFD,0xFFDD,0xFCFD,0xDDFD,0xF9FD,0xFBFD,0xFBFD,0xE2DD,0xFF9D,0xFFFD,0xFFDD,0xFF0D,0xFE7D,0xFCED,0xFCFD,0xFE7D,0xFF3D,0xFF9D,0xFFFD,0xE7BD,0xF73D,0xF57D,0xF9FD,0xFFED,0xFCED,0xFE7D,0xFF3D,0xFFED,0xFF0D,0xFF3D,0xFF9D,0xFF3D,0xFF7D,0xFF7D,0xF0FD,0xF3FD,0xFFFD,0xFF3D,0xFE3D,0xFDFD,0xFE7D,0xFF7D,0xFF7D,0xF97D,0xF8FD,0xFFFD,0xFFFD,0xFEFD,0xFCFD,0xFCFD,0xFCFD,0xF9FD,0xFDFD,0xFBFD,0xFBFD,0xF9FD,0xFFFD,0xFFFD,0xFF7D,0xFE7D,0xF97D,0xFAFD,0xF1FD,0xFFFD,0xF9FD,0xF0FD,0xFFFD,0xFFFD,0xFB6D,0xE245,0xFA6D,0xF74D,0xF67D,0xE6CD,0xFC95,0xE7DD,0xFFFD,0xFFFD,0xFFFD,0xFFFD},{0xFFFE,0xFFFE,0xFEDE,0xFDDE,0xFF9E,0xFDBE,0xFFBE,0xFF3E,0xFF7E,0xFF7E,0xFE7E,0xFEFE,0xEEFE,0xE5FE,0xFFFE,0xFFFE,0xFFFE,0xFFFE,0xF276,0xEEFE,0xFEFE,0xDCFE,0xDC1E,0xEDFE,0xFDFE,0xF9FE,0xFBE6,0xF02E,0xFFFE,0xFFFE,0xFFFE,0xFF6E,0xFEEE,0xFEFE,0xFEFE,0xFE7E,0xFF3E,0xFFBE,0xFF9E,0xFF9E,0xE7BE,0xF27E,0xFFFE,0xFFFE,0xFC6E,0xFF6E,0xFF6E,0xFF2E,0xFFBE,0xFF9E,0xFFBE,0xFFBE,0xFF7E,0xFEFE,0xF1FE,0xFFFE,0xFFFE,0xFFFE,0xFE9E,0xFEFE,0xFEFE,0xFE7E,0xFF3E,0xFB3E,0xFC7E,0xFFFE,0xFFFE,0xFEFE,0xFEFE,0xF87E,0xFDFE,0xFDFE,0xF9FE,0xF9FE,0xF87E,0xF9FE,0xFFFE,0xFFFE,0xFFFE,0xFD3E,0xFF3E,0xFB7E,0xFBFE,0xF3FE,0xF27E,0xF9FE,0xFFFE,0xFFFE,0xFFFE,0xF24E,0xF12E,0xF26E,0xF6CE,0xF6DE,0xE6DE,0xECCE,0xFFFE,0xFFFE,0xFFFE,0xFFFE}};
	int key=0,y=16;
	int sound=1;
	Sprite16_XOR(0,0,100,logo[0],GetPlane(LIGHT_PLANE));
	Sprite16_XOR(0,0,100,logo[1],GetPlane(DARK_PLANE));

	SetPlane(DARK_PLANE);
	FontSetSys (F_6x8);
	printf_xy(20,2,"--[ JesBean v1.0a ]--");
	FontSetSys (F_4x6);
	printf_xy(25,16,"Start new game");
	printf_xy(25,24,"Sound: OFF");
	printf_xy(25,32,"Quit");
	
	
	printf_xy(20,y,">");
	
	while(1) {
		key=ngetchx();
		if ((key==KEY_DOWN) && (y<32))
		{
			printf_xy(20,y,"  ");
			y+=8;	
			printf_xy(20,y,">");
		}
		if ((key==KEY_UP) && (y>16))
		{
			printf_xy(20,y,"  ");
			y-=8;	
			printf_xy(20,y,">");
		}
		if (key==KEY_ENTER)
		{
			if (y==16) return sound; // 1 = go
			if (y==24) {
				if (sound==1) {
				  sound=2;
			  	printf_xy(25,24,"Sound: ON  ");	
				} else {
					sound=1;
					printf_xy(25,24,"Sound: OFF");
				}
			}
			if (y==32) return 0; // 0 == EXIT
		}
	}
	return 1;
}

// Startup function.
void _main(void)
{
	int start=0;
	if (!GrayOn()) return;
	HW2 = IsRealHW2() ;
	ClearGrayScreen2B(GetPlane(LIGHT_PLANE),GetPlane(DARK_PLANE));
	start=Menu();
	if (start>0) Run_Game(start);
	GrayOff();
}
